#include <stdio.h>
#include <string.h>
#include <stdlib.h>
typedef struct element *POKAZIVAC;
typedef struct element{
	char sifra[3];
	char naziv[50];
	POKAZIVAC sledeci;
}DOBAVLJAC;


typedef struct proizvod *POKAZIVACnaPROIZVOD;
typedef struct proizvod{
	char sifraDobavljaca[3];
	char sifraProizvoda[3];
	char nazivProizvoda[50];
	double cena;
	POKAZIVACnaPROIZVOD sledeci;
}PROIZVOD;

void ubaciElNaKrajListeDobavljaca(POKAZIVAC *glava,char sifra[], char naziv[]){
	POKAZIVAC cvor;
	POKAZIVAC tek = *glava;
	cvor = malloc(sizeof(DOBAVLJAC));
	strcpy(cvor->sifra, sifra);
	strcpy(cvor->naziv, naziv);
	cvor->sledeci = NULL;

	if(*glava != NULL){
		while(tek->sledeci != NULL){
			tek = tek->sledeci;
		}
		tek->sledeci = cvor;
	}else{
		*glava = cvor;

	}
}

void ubaciElNaKrajListeProizvoda(POKAZIVAC glavaD, POKAZIVACnaPROIZVOD *glavaP,char sifraD[], char sifraP[], char nazivP[], double cena){
	int znak = 1;
	POKAZIVACnaPROIZVOD cvorP;
	POKAZIVAC tekD;
	POKAZIVACnaPROIZVOD tekP;
	tekP = *glavaP;
	tekD = glavaD;

	while(tekD != NULL){
		if(strcmp(tekD->sifra, sifraD) == 0){
			cvorP = malloc(sizeof(PROIZVOD));
			strcpy(cvorP->sifraDobavljaca, sifraD);
			strcpy(cvorP->sifraProizvoda, sifraP);
			strcpy(cvorP->nazivProizvoda, nazivP);
			cvorP->cena = cena;
			cvorP->sledeci = NULL;

			if(*glavaP != NULL){
				while(tekP->sledeci != NULL){
					tekP = tekP->sledeci;
				}
				tekP->sledeci = cvorP;
			}else{
				*glavaP = cvorP;

			}
		}

		tekD = tekD->sledeci;
	}

}

void prikaziListu(POKAZIVAC glavaD, POKAZIVACnaPROIZVOD glavaP){
	FILE *f;
	POKAZIVAC tek;
	POKAZIVACnaPROIZVOD tekP;
	tek = glavaD;
	tekP = glavaP;

	f = fopen("C:\\Cdat\\Dobavljaci.txt", "wt");
	if(f == NULL){
		printf("Datoteka nije otvorena");
		return;
	}
	while(tek != NULL){
		fprintf(f,"\nDobavljac: \n");
		fprintf(f, "Sifra: ");
		fprintf(f, "\t Naziv: \n");
		fprintf(f, "%s", tek->sifra);
		fprintf(f, "\t");
		fprintf(f, "%s", tek->naziv);
		fprintf(f, "\n Proizvodi:\n");
		fprintf(f, "\tSifra: \t Naziv: \tCena: \n");
		tekP = glavaP;
		while(tekP != NULL){
			if(strcmp(tek->sifra, tekP->sifraDobavljaca) == 0){
				fprintf(f, "\t%s \t%s \t%.2lf\n", tekP->sifraProizvoda, tekP->nazivProizvoda, tekP->cena);
			}
			tekP = tekP->sledeci;
		}
		tek = tek->sledeci;
	}
	fprintf(f,"\n");
	fclose(f);
}

int main(void){
	POKAZIVAC glavaD;
	POKAZIVACnaPROIZVOD	glavaP;
	glavaD = NULL;
	glavaP = NULL;

	ubaciElNaKrajListeDobavljaca(&glavaD, "D1", "Dobavljac 1");
	ubaciElNaKrajListeDobavljaca(&glavaD, "D2", "Dobavljac 2");


	ubaciElNaKrajListeProizvoda(glavaD,&glavaP, "D1", "P1", "Proizvod 1", 30.50);
	ubaciElNaKrajListeProizvoda(glavaD,&glavaP, "D1", "P2", "Proizvod 2", 50.40);
	ubaciElNaKrajListeProizvoda(glavaD,&glavaP, "D2", "P3", "Proizvod 3", 30.50);
	prikaziListu(glavaD, glavaP);

return 0;
}
