#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct student{
	char brIndeksa[9];
	char imePrezime[30];
	int brKolokvijuma;
	int brPoena;
}STUDENT;

typedef struct element *POKAZIVAC;
typedef struct element{
	STUDENT podatak;
	POKAZIVAC sledeci;
}ELEMENT;
typedef struct nisu_polozili{
	char brIndeksa[9];
	char imePrezime[30];
	int brPrviKol;
	int brDrugiKol;
	int zbir;

}NISUPOLOZILI;
typedef struct glava_rep *LISTA;
typedef struct glava_rep{
	POKAZIVAC glava;
	POKAZIVAC rep;
}GLAVA_REP;


void inicijalizujlistu(LISTA *lista){
	*lista=malloc(sizeof(LISTA));
	(*lista)->glava=NULL;
	(*lista)->rep=NULL;

}
int daLiPostoji(char brIndeksa[],int brKolokvijuma,LISTA lista){
	POKAZIVAC pom=lista->glava;

	while(pom!=NULL){
		if(strcmp(pom->podatak.brIndeksa, brIndeksa)==0 && pom->podatak.brKolokvijuma==brKolokvijuma)
			return 1;

		pom=pom->sledeci;
	}

	return 0;
}
void ubaciuListu(LISTA lista){
	POKAZIVAC noviEl=malloc(sizeof(ELEMENT));
	int postoji;
	char brIndeksa[9];
	char imePrezime[30];
	int brKolokvijuma;
	int brPoena;

	printf("unesi broj indeksa");
	fflush(stdin);
	gets(brIndeksa);
	fflush(stdin);

	printf("unesi ime i prezime");
	fflush(stdin);
	gets(imePrezime);
	fflush(stdin);

	printf("unesi br kolokvijuma ");
	scanf("%d",&brKolokvijuma);

	printf("unesi broj poena");
	scanf("%d",&brPoena);

	postoji=daLiPostoji(brIndeksa,brKolokvijuma,lista);

	if(postoji==1)
		printf("rezultat vec postoji u listi");
	else{
		strcpy(noviEl->podatak.brIndeksa,brIndeksa);
		strcpy(noviEl->podatak.imePrezime,imePrezime);
		noviEl->podatak.brPoena=brPoena;
		noviEl->podatak.brKolokvijuma=brKolokvijuma;

		noviEl->sledeci=lista->glava;
		lista->glava=noviEl;

		if(lista->rep==NULL)
			lista->rep=noviEl;
	}

}

int nadjiBrPoena(LISTA lista, char brIndeksa[] ,int brkolokvijuma){
	POKAZIVAC pom=lista->glava;
	while(pom!=NULL){
		if(strcmp(pom->podatak.brIndeksa,brIndeksa)==0 && pom->podatak.brKolokvijuma==brkolokvijuma)
			return pom->podatak.brPoena;

		pom=pom->sledeci;
	}
	return 0;
}

int postoji(char brIndeksa[],NISUPOLOZILI niz[],int brel){
	int i;
	for(i=0;i<brel;i++){
		if(strcmp(niz[i].brIndeksa,brIndeksa)==0)
			return 1;
	}
	return 0;
}
void unesi(NISUPOLOZILI niz[],int *brel,int prviKol,int drugiKol,int zbir,char imePrezime[],char brIndeksa[]){
	NISUPOLOZILI novi;
	int i,j;
	novi.brDrugiKol=drugiKol;
	novi.zbir=zbir;
	novi.brPrviKol=prviKol;
	strcpy(novi.brIndeksa,brIndeksa);
	strcpy(novi.imePrezime,imePrezime);
	if(postoji(brIndeksa,niz,*brel)==1)
		return;
	if(*brel==0){
		niz[0]=novi;
		*brel=*brel+1;
		return;
	}
	for(i=0;i<*brel;i++){
		if(novi.zbir>niz[i].zbir){
			for(j=*brel;j>i;j--){
				niz[j]=niz[j-1];
			}
			niz[i]=novi;
			*brel=*brel+1;
		}

	}
	niz[i]=novi;
	*brel=*brel+1;

}
void napraviSortNiz(LISTA lista,NISUPOLOZILI niz[],int *brel){
	int prviKol;
	int drugiKol;
	int zbir;
	POKAZIVAC pom=lista->glava;

	while(pom!=NULL){
		prviKol=nadjiBrPoena(lista, pom->podatak.brIndeksa,1);
		drugiKol=nadjiBrPoena(lista, pom->podatak.brIndeksa,2);
		zbir=prviKol+drugiKol;

		if(prviKol<15 || drugiKol<15 || zbir<45)
			unesi(niz, brel,prviKol,drugiKol,zbir,pom->podatak.imePrezime,pom->podatak.brIndeksa);

		pom=pom->sledeci;
	}

}
void napraviIzvestaj(LISTA lista){
	NISUPOLOZILI niz[50];
	int brel=0,i;
	FILE *dat;
	dat=fopen("nisu_polozili.txt","w");

	if(dat==NULL){
		printf("greska! ");
		return;
	}
	napraviSortNiz(lista,niz,&brel);

	fprintf(dat,"Rb\tBr indeksa\tIme i prezime\tI\tII\tzbir\n");
	for(i=0;i<brel;i++){
		fprintf(dat,"%15d%s%s%15d%15d%15d\n",i+1,niz[i].brIndeksa,niz[i].imePrezime,niz[i].brPrviKol,niz[i].brDrugiKol,niz[i].zbir);
	}
	fclose(dat);
}
int main (void){
	LISTA lista;
	int brRez=1;

	inicijalizujlistu(&lista);

	while(brRez==1){
	ubaciuListu(lista);
	printf("Da li zelis jos rezultata? 1-da 2-ne");
	scanf("%d",&brRez);
	}

	napraviIzvestaj(lista);

return 0;
}
